//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;                

//---------------------------------------------------------------------------
char* fgets2(FILE* f,char* line)   //Afin d'ignorer les lignes qui commencent par %
{ char* r;
  do   { r=fgets(line,256,f);}  while (((line[0]=='%')||(line[1]=='%'))&&(r!= NULL));
  return r;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner):TForm(Owner)
{
}


//---------------------------------------------------------------------------
void TForm1::Solve()
{   Memo1->Text="k = "+String(k)+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"kmax = "+String(kmax)+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"t[k] = "+String(t[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"u1[k] = "+String(u1[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"u2[k] = "+String(u2[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"cond[k] = "+String(cond[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"deltas[k] = "+String(deltas[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"x[k] = "+String(x[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"y[k] = "+String(y[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"theta[k] = "+String(theta[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"dx[k] = "+String(dx[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"dy[k] = "+String(dy[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"dtheta[k] = "+String(dtheta[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"ddx[k] = "+String(ddx[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"ddy[k] = "+String(ddy[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"ddtheta[k] = "+String(ddtheta[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"fr[k] = "+String(fr[k])+" \r\n ";
    Memo1->Text=Form1->Memo1->Text+"fs[k] = "+String(fs[k])+" \r\n ";
    Memo1->Refresh();
    R1.Clean();
    R2.Clean();
    //R_trueword.Clean();
    //R_wordhat.Clean();
    { GO(amin,amax,psimin,psimax);
      R1.image->Refresh();
      R2.image->Refresh();
      R_trueword.image->Refresh();
      R_wordhat.image->Refresh();
      R_fs.image->Refresh();
      R_fr.image->Refresh();
      R_a.image->Refresh();
      R_psi.image->Refresh();
      R_cond.image->Refresh();
      R_deltas.image->Refresh();
    }
    //Image1->Picture->SaveToFile("wind"+String(10000+k)+".bmp");
    //Image2->Picture->SaveToFile("forces"+String(10000+k)+".bmp");
    //Image_trueword->Picture->SaveToFile("trueword"+String(10000+k)+".bmp");
    //Image_wordhat->Picture->SaveToFile("wordhat"+String(10000+k)+".bmp");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{   if (TrackBar1->Position>kmax)   TrackBar1->Position=kmax-1;
    k= TrackBar1->Position ;
    Solve();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  for (k=1;k<=kmax-1;k=k+1)     //increment de 20 pour la figure
  {   Solve();
      TrackBar1->Position=k;
  }
  Image_fs->Picture->SaveToFile("fs.bmp");
  Image_fr->Picture->SaveToFile("fr.bmp");
  Image_a->Picture->SaveToFile("a.bmp");
  Image_psi->Picture->SaveToFile("psi.bmp");
  Image_cond->Picture->SaveToFile("cond.bmp");
  Image_deltas->Picture->SaveToFile("deltas.bmp");
  Image_wordhat->Picture->SaveToFile("wordhat.bmp");
  Image_trueword->Picture->SaveToFile("trueword.bmp");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)   // Testcase 1
{   t.clear();
    FILE *fdata;
    char line[256];
    fdata = fopen("data_testcase1.txt","r");
//    % p1 p2 p3 p4 p5 p6 p7 p8 p9 p10
    fgets2(fdata,line);
    sscanf(line,"%lf%lf%lf%lf%lf%lf%lf%lf%lf%lf",&p1,&p2,&p3,&p4,&p5,&p6,&p7,&p8,&p9,&p10);

//    '% e_u e_xy e_theta e_dxy e_dtheta e_ddxy  e_ddtheta');
    fgets2(fdata,line);
    sscanf(line,"%lf%lf%lf%lf%lf%lf%lf",&e_u,&e_xy,&e_theta, &e_dxy, &e_dtheta, &e_ddxy, &e_ddtheta);


    double t1, u11 ,u21, cond1, deltas1, x1, y1, theta1, v1, dx1, dy1, dtheta1,
           dv1, ddx1, ddy1,ddtheta1, fr1, fs1, a1, psi1;
    while (fgets2(fdata,line) != NULL)
    {   sscanf(line,"%lf%lf%lf%lf%lf",   &t1,   &u11,  &u21,    &cond1, &deltas1);
        fgets2(fdata,line);
        sscanf(line,"%lf%lf%lf%lf",   &x1,   &y1,   &theta1, &v1);
        fgets2(fdata,line);
        sscanf(line,"%lf%lf%lf%lf",   &dx1,  &dy1,  &dtheta1, &dv1);
        fgets2(fdata,line);
        sscanf(line,"%lf%lf%lf",&ddx1, &ddy1, &ddtheta1);
        fgets2(fdata,line);
        sscanf(line,"%lf%lf%lf%lf%",&fr1,    &fs1,   &a1,  &psi1);
        t.push_back(t1);
        u1.push_back(u11);            U1.push_back(u11+interval(-e_u,e_u));
        u2.push_back(u21);            U2.push_back(u21+interval(-e_u,e_u));
        cond.push_back(cond1);
        deltas.push_back(deltas1);
        x.push_back(x1);              X.push_back(x1+interval(-e_xy,e_xy));
        y.push_back(y1);              Y.push_back(y1+interval(-e_xy,e_xy));
        theta.push_back(theta1);      Theta.push_back(theta1+interval(-e_theta,e_theta));
        v.push_back(v1);
        dx.push_back(dx1);            dX.push_back(dx1+interval(-e_dxy,e_dxy));
        dy.push_back(dy1);            dY.push_back(dy1+interval(-e_dxy,e_dxy));
        dtheta.push_back(dtheta1);    dTheta.push_back(dtheta1+interval(-e_dtheta,e_dtheta));
        dv.push_back(dv1);
        ddx.push_back(ddx1);          ddX.push_back(ddx1+interval(-0.1*e_ddxy,0.1*e_ddxy));
        ddy.push_back(ddy1);          ddY.push_back(ddy1+interval(-0.1*e_ddxy,0.1*e_ddxy));
        ddtheta.push_back(ddtheta1);  ddTheta.push_back(ddtheta1+interval(-0.1*e_ddtheta,0.1*e_ddtheta));
        fr.push_back(fr1);
        fs.push_back(fs1);
        a.push_back(a1);
        psi.push_back(psi1);
    }
    kmax=t.size();
    tmax=t[kmax-1];
    TrackBar1->Max=kmax-1;
    fclose(fdata);

    amin=0;    psimin=0;    amax=15;    psimax=6.28;
    R_fs=repere(Image_fs,0,tmax,-10000,10000);
    R_fr=repere(Image_fr,0,tmax,-1000,1000);
    R_a=repere(Image_a,0,tmax,amin,amax);
    R_psi=repere(Image_psi,0,tmax,psimin,psimax);
    R_cond=repere(Image_cond,0,tmax,-2,2);
    R_deltas=repere(Image_deltas,0,tmax,-2,2);
    R1=repere(Image1,-amax,amax,-amax,amax);
    R2=repere(Image2,-400,800,-11000,11000);
    int larg=120; int xmin=-80; int ymin=-30;
    R_trueword=repere(Image_trueword,xmin,xmin+larg,ymin,ymin+larg);
    R_wordhat=repere(Image_wordhat,xmin,xmin+larg,ymin,ymin+larg);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{   t.clear();
    FILE *fdata;
    char line[256];
    fdata = fopen("data_testcase2.txt","r");
//    % p1 p2 p3 p4 p5 p6 p7 p8 p9 p10
    fgets2(fdata,line);  sscanf(line,"%lf",&p1);
    fgets2(fdata,line);  sscanf(line,"%lf",&p2);
    fgets2(fdata,line);  sscanf(line,"%lf",&p3);
    fgets2(fdata,line);  sscanf(line,"%lf",&p4);
    fgets2(fdata,line);  sscanf(line,"%lf",&p5);
    fgets2(fdata,line);  sscanf(line,"%lf",&p6);
    fgets2(fdata,line);  sscanf(line,"%lf",&p7);
    fgets2(fdata,line);  sscanf(line,"%lf",&p8);
    fgets2(fdata,line);  sscanf(line,"%lf",&p9);
    fgets2(fdata,line);  sscanf(line,"%lf",&p10);


//    '% e_u e_xy e_theta e_dxy e_dtheta e_ddxy  e_ddtheta');
    fgets2(fdata,line);  sscanf(line,"%lf",&e_u);
    fgets2(fdata,line);  sscanf(line,"%lf",&e_xy);
    fgets2(fdata,line);  sscanf(line,"%lf",&e_theta);
    fgets2(fdata,line);  sscanf(line,"%lf",&e_dxy);
    fgets2(fdata,line);  sscanf(line,"%lf",&e_dtheta);
    fgets2(fdata,line);  sscanf(line,"%lf",&e_ddxy);
    fgets2(fdata,line);  sscanf(line,"%lf",&e_ddtheta);


    double t1, u11 ,u21, cond1, deltas1, x1, y1, theta1, v1, dx1, dy1, dtheta1,
           dv1, ddx1, ddy1,ddtheta1, fr1, fs1, a1, psi1;
    while (fgets2(fdata,line) != NULL)
    {   sscanf(line,"%lf",&t1);
        fgets2(fdata,line); sscanf(line,"%lf", &u11);
        fgets2(fdata,line); sscanf(line,"%lf", &u21);
        fgets2(fdata,line); sscanf(line,"%lf", &cond1);
        fgets2(fdata,line); sscanf(line,"%lf", &deltas1);
        fgets2(fdata,line); sscanf(line,"%lf", &x1);
        fgets2(fdata,line); sscanf(line,"%lf", &y1);
        fgets2(fdata,line); sscanf(line,"%lf", &theta1);
        fgets2(fdata,line); sscanf(line,"%lf", &v1);
        fgets2(fdata,line); sscanf(line,"%lf", &dx1);
        fgets2(fdata,line); sscanf(line,"%lf", &dy1);
        fgets2(fdata,line); sscanf(line,"%lf", &dtheta1);
        fgets2(fdata,line); sscanf(line,"%lf", &dv1);
        fgets2(fdata,line); sscanf(line,"%lf", &ddx1);
        fgets2(fdata,line); sscanf(line,"%lf", &ddy1);
        fgets2(fdata,line); sscanf(line,"%lf", &ddtheta1);
        fgets2(fdata,line); sscanf(line,"%lf", &fr1);
        fgets2(fdata,line); sscanf(line,"%lf", &fs1);
        fgets2(fdata,line); sscanf(line,"%lf", &a1);
        fgets2(fdata,line); sscanf(line,"%lf", &psi1);
        t.push_back(t1);
        u1.push_back(u11);            U1.push_back(u11+interval(-e_u,e_u));
        u2.push_back(u21);            U2.push_back(u21+interval(-e_u,e_u));
        cond.push_back(cond1);
        deltas.push_back(deltas1);
        x.push_back(x1);              X.push_back(x1+interval(-e_xy,e_xy));
        y.push_back(y1);              Y.push_back(y1+interval(-e_xy,e_xy));
        theta.push_back(theta1);      Theta.push_back(theta1+interval(-e_theta,e_theta));
        v.push_back(v1);
        dx.push_back(dx1);            dX.push_back(dx1+interval(-e_dxy,e_dxy));
        dy.push_back(dy1);            dY.push_back(dy1+interval(-e_dxy,e_dxy));
        dtheta.push_back(dtheta1);    dTheta.push_back(dtheta1+interval(-e_dtheta,e_dtheta));
        dv.push_back(dv1);
        ddx.push_back(ddx1);          ddX.push_back(ddx1+interval(-0.1*e_ddxy,0.1*e_ddxy));
        ddy.push_back(ddy1);          ddY.push_back(ddy1+interval(-0.1*e_ddxy,0.1*e_ddxy));
        ddtheta.push_back(ddtheta1);  ddTheta.push_back(ddtheta1+interval(-0.1*e_ddtheta,0.1*e_ddtheta));
        fr.push_back(fr1);
        fs.push_back(fs1);
        a.push_back(a1);
        psi.push_back(psi1);
    }
    kmax=t.size();
    tmax=t[kmax-1];
    TrackBar1->Max=kmax-1;
    fclose(fdata);

    amin=0;    psimin=0;    amax=15;    psimax=6.28;
    R_fs=repere(Image_fs,0,tmax,-10000,10000);
    R_fr=repere(Image_fr,0,tmax,-1000,1000);
    R_a=repere(Image_a,0,tmax,amin,amax);
    R_psi=repere(Image_psi,0,tmax,psimin,psimax);
    R_cond=repere(Image_cond,0,tmax,-2,2);
    R_deltas=repere(Image_deltas,0,tmax,-2,2);
    R1=repere(Image1,-amax,amax,-amax,amax);
    R2=repere(Image2,-400,800,-11000,11000);
    R_trueword=repere(Image_trueword,-120,30,-80,70);
    R_wordhat=repere(Image_wordhat,-120,30,-80,70);
}
//---------------------------------------------------------------------------

